<template>
  <section
    ref="lang-switcher"
    class="lang-switcher"
    :class="{ open: langSwitcherIsActive }"
    @click="langSwitcherIsActive = !langSwitcherIsActive"
  >
    <button
      v-closable="{
        exclude: ['lang-switcher'],
        handler: 'onClose'
      }"
      class="lang-switcher_trigger heading"
      data-toggle="dropdown"
      aria-haspopup="true"
      aria-expanded="true"
      :title="$t('header.changeLanguage')"
    >
      <span :lang="$i18n.locale">
        <img
          :src="require(`~/assets/images/flag-${$i18n.locale}.svg`)"
          width="16"
          height="12"
          alt=""
        />
        {{ $i18n.locale.toUpperCase() }}
      </span>
    </button>
    <ul class="lang-switcher_content">
      <li
        v-for="(hrefLang, key) in hrefLangs"
        :key="key"
        class="lang-switcher_item"
        :class="{ current: $i18n.locale === key }"
      >
        <a
          v-if="$utils.isHomepage()"
          class="lang-switcher_item-link heading"
          rel="alternate"
          :href="hrefLang"
          :hreflang="key"
          :lang="key"
          :title="$t(`header.lang-switcher.${key}`)"
        >
          <img
            :src="require(`~/assets/images/flag-${key}.svg`)"
            width="16"
            height="12"
            alt=""
          />
          {{ key.toUpperCase() }}
        </a>
        <span
          v-else
          class="lang-switcher_item-link heading role-link"
          :hreflang="key"
          :lang="key"
          @click="langClick(hrefLang)"
        >
          <img
            :src="require(`~/assets/images/flag-${key}.svg`)"
            width="16"
            height="12"
            alt=""
          />
          {{ key.toUpperCase() }}
        </span>
      </li>
    </ul>
    <select v-model="langUrl" class="lang-switcher_select">
      <option value="/en/">English</option>
      <option selected="" value="/fr/">Français</option>
      <option value="/de/">Deutsch</option>
      <option value="/nl/">Dutch</option>
      <option value="/it/">Italiana</option>
    </select>
  </section>
</template>

<script>
export default {
  name: 'LangSwitcher',
  data() {
    return {
      langSwitcherIsActive: false,
      langUrl: '/fr/'
    }
  },

  computed: {
    currentRouteName() {
      return this.$nuxt.$route.name ? this.$nuxt.$route.name : ''
    },

    hrefLangs() {
      // returns the array of urls for lang switcher UI
      // when current page is a serie or an album (or any other from replaced list),
      // the resulting url for languages other than current will be replaced by localized home url.
      // all other cases : just switch current language in url
      // (current: izneo.com/fr/panier, new: izneo.com/en/shopping-cart)
      // in some cases will result in 404

      // create an obj from lang array with keys/values for all languages
      const langs = this.$i18n.locales.reduce(
        (obj, v) => ((obj[v] = '#'), obj),
        {}
      )

      for (const langsKey in langs) {
        // redirect from subscription TO home
        if (langsKey !== 'fr' && langsKey !== 'en') {
          if (this.$parent.currentRouteName.indexOf('subscription___') === 0) {
            langs[langsKey] = this.homeUrlForCurrentArea(langsKey)
            continue
          }
        }

        // for nuxt's 404 page, this.switchLocalePath returns empty string
        // switched from this.switchLocalePath to window.location.pathname.replace
        //langs[langsKey] = this.switchLocalePath(langsKey)
        langs[langsKey] = this.$nuxt.$route.fullPath.replace(
          /^\/\w{2}(.*)/gim,
          `/${langsKey}$1`
        )
      }

      return langs
    }
  },

  watch: {
    langUrl() {
      window.location = this.langUrl
    }
  },

  methods: {
    onClose() {
      this.langSwitcherIsActive = false
    },

    homeUrlForCurrentArea(lang) {
      return this.$utils.storeArea
        ? this.$utils.homeUrlForLang(lang)
        : this.$utils.homeAboUrlForLang(lang)
    },

    langClick(url) {
      window.location.href = url
    }
  }
}
</script>

<style
  lang="scss"
  src="~/assets/scss/v7/components/atoms/lang-switcher/_lang-switcher.scss"
></style>

<style lang="scss" scoped>
.role-link {
  cursor: pointer;
}
</style>
